// chuk_trainer.c/
// functions to utilize wired Nintendo Wii nunchuk and clones.
// Uses tincantools.com Trainer, BeagleBoard, 
// Nintendo Wii nunchuk and clones.
// 29.10.2010 21:04:29
// djl
// rev 0.4
// 
// pressing C and Z buttons together terminates program

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <linux/i2c-dev.h>
#include "chuk_trainer.h"

// local functions to display chuk data
void print_raw();
void print_real();

// functions in chuk_com.c
void i2c_bus_init();
void i2c_chuk_init();
void i2c_chuk_read();
void chuk_data();

int i;

int main(void)
{

	//Init I2C-2 bus and nunchuk, see chuk_com.c
	i2c_bus_init();		// in chuk_com.c
	i2c_chuk_init();	// in chuk_com.c

// loop chuk data display
do
{
	print_real();	// print chuk output to console

}while(z_button + c_button != 0); //press both buttons on chuk to exit
	printf("\n");

	return(-1);
}
// print_raw() prints raw nunchuk data in hex
void print_raw()
{
	printf("Nunchuk Addr: %x Data: ",i2c_addr);
    for(i=0; i < read_bytes; i++)
    {
        printf("%x ", buf[i]);
    }
    printf("\n");
}

// print_real() prints real nunchuk data in decimal
// This routine shows sharing of nunchuk data between functions
// in separate code segments using a buffer.
void print_real()
{
	// Initialize some variables
	z_button = 0;
	c_button = 0;
	accel_x  = 0;
	accel_y  = 0;
	accel_z  = 0;
	i2c_chuk_read();	// in chuk_com.c
		
// buf[5] contains buttons C (top) Z(bottom) and 2 bits
// of accel data of x y x axis

	// Joysticks data
	joy_x = buf[0];
	joy_y = buf[1];
// acceleration per axis data is 10 bits but output of chuk is 6 bytes
// these variables are longs so we shift the byte two bits left
// to make room for two more bits stored in the 6th byte (see table)
	accel_x += ((buf[2]) << 2); // 8 bits of data, byte 3
	accel_y += ((buf[3]) << 2); // 8 bits of data byte 4
	accel_z += ((buf[4]) << 2); // 8 bits of data byte 5
// get two bits for each axis from 6th byte and place into
// the long variable
	// acceleronometer data
	accel_x += ((buf[5]) >> 2) & 0x03; //byte 6 bits 3,4
	accel_y += ((buf[5]) >> 4) & 0x03; //byte 6 bits 5,6
	accel_z += ((buf[5]) >> 6) & 0x03; //byte 6 bits 7,8
	
	// Buttons Z and C data byte 6 bits 1,2
	if ((buf[5] & 0x01) !=0) {
		z_button = 1;
		data_buf[5] = z_button;
	}
	if ((buf[5] & 0x02) !=0) {
		c_button = 1;
		data_buf[6] = c_button;
	}
        printf("Joy_x: %d, ", joy_x);	
	    printf("Joy_y: %d, ", joy_y);
        printf("Accel_x: %ld, ", accel_x);	
        printf("Accel_y: %ld, ", accel_y);	
        printf("Accel_z: %ld, ", accel_z);	
        printf("B_Z: %d, ", z_button);	
        printf("B_C: %d \r", c_button);	

}
  
